package ch.unisg.executorcomputation.executor.domain;

import java.util.concurrent.TimeUnit;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import ch.unisg.executorbase.executor.domain.ExecutorBase;
import ch.unisg.executorbase.executor.domain.ExecutorType;

public class Executor extends ExecutorBase {

    private static Logger executorLogger = Logger.getLogger(Executor.class.getName());

    private static final Executor executor = new Executor(ExecutorType.COMPUTATION);

    public static Executor getExecutor() {
        return executor;
    }

    private Executor(ExecutorType executorType) {
        super(executorType);
    }

    @Override
    protected
    String execution(String inputData) {

        executorLogger.info("Executor | Starting execution with inputData: " + inputData);

        ScriptEngineManager mgr = new ScriptEngineManager();
        ScriptEngine engine = mgr.getEngineByName("JavaScript");

        String result = "";
        try {
            result = engine.eval(inputData).toString();
        } catch (ScriptException e1) {
            // TODO some logic if execution fails
            executorLogger.severe(e1.getMessage());
            return result;
        }

        try {
            TimeUnit.SECONDS.sleep(1);
        } catch (InterruptedException e) {
            return result;
            // executorLogger.log(Level.SEVERE, e.getLocalizedMessage(), e);
            // Thread.currentThread().interrupt();
        }

        executorLogger.info("Executor | Finish execution");
        return result;
    }

}
