package ch.unisg.roster.roster.application.port.in;

import java.net.URI;

import javax.validation.constraints.NotNull;

import ch.unisg.roster.roster.domain.valueobject.ExecutorType;
import ch.unisg.common.validation.SelfValidating;
import lombok.EqualsAndHashCode;
import lombok.Value;

@Value
@EqualsAndHashCode(callSuper=false)
public class NewTaskCommand extends SelfValidating<NewTaskCommand> {

    @NotNull
    private final String taskID;

    @NotNull
    private final ExecutorType taskType;

    private final String inputData;

    private final String taskUri;

    public NewTaskCommand(String taskID, String taskUri, ExecutorType taskType, String inputData) {
        this.taskID = taskID;
        this.taskUri = taskUri;
        this.taskType = taskType;
        this.inputData = inputData;
        this.validateSelf();
    }
}
