package ch.unisg.tapas.auctionhouse.adapter.in.messaging.websub;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.HttpHeaders;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

/**
 * This class is a template for handling auction started events received via WebSub
 */
@RestController
public class DiscoverWebSubAdapter {

    @Value("${websub.hub.uri}")
    private String webSubHubUri;

    @Value("${auction.house.uri}")
    private String auctionHouseUri;

    /**
    *   Controller to discover our websub topic
    *   @return 200 OK
    **/
    @GetMapping(path = "/websub/auctions")
    public ResponseEntity<String> handleDiscoverWebSubAuction() {

        HttpHeaders header = new HttpHeaders();
        header.add("link", "<" + auctionHouseUri + "/auctions/>; rel=\"self\"");
        header.add("link", "<" + webSubHubUri + ">; rel=\"hub\"");

        return ResponseEntity.ok().headers(header).body("");
    }
}
