package ch.unisg.tapas.auctionhouse.application.port.in;

import ch.unisg.common.valueobject.ExecutorURI;

import ch.unisg.tapas.common.SelfValidating;
import lombok.Value;

import javax.validation.constraints.NotNull;

/**
 * Event that notifies the auction house that an executor has been removed from this TAPAS application.
 */
@Value
public class ExecutorRemovedEvent extends SelfValidating<ExecutorRemovedEvent> {
    @NotNull
    private final ExecutorURI executorUri;

    /**
     * Constructs an executor removed event.
     *
     * @param executorUri
     */
    public ExecutorRemovedEvent(ExecutorURI executorUri) {
        this.executorUri = executorUri;
        this.validateSelf();
    }
}
